<template>
  <div class="container">
    <h2>Register</h2>
    <form @submit.prevent="register" class="register-form">
      <div class="form-group">
        <label for="username">Username:</label>
        <input type="text" v-model="username" class="form-control" required>
      </div>
      <div class="form-group">
        <label for="password">Password:</label>
        <input type="password" v-model="password" class="form-control" required>
      </div>
      <div class="form-group">
        <label for="firstName">First Name:</label>
        <input type="text" v-model="firstName" class="form-control" required>
      </div>
      <div class="form-group">
        <label for="lastName">Last Name:</label>
        <input type="text" v-model="lastName" class="form-control" required>
      </div>
      <div class="form-group">
        <label for="gender">Gender:</label>
        <input type="text" v-model="gender" class="form-control" required>
      </div>
      <div class="form-group">
        <label for="dateOfBirth">Date of Birth:</label>
        <input type="date" v-model="dateOfBirth" class="form-control" required>
      </div>

      <!-- Polje za izbor uloge, prikazuje se samo ako je administrator -->
      <div v-if="isAdmin" class="form-group">
        <label for="role">Role:</label>
        <select v-model="selectedRole" class="form-control">
          <option value="Menadzer">Manager</option>
          <option value="Radnik">Worker</option>
          <option value="Kupac">Customer</option>
        </select>
      </div>

      <!-- Polje za unos naziva fabrike, prikazuje se samo ako je menadžer ili administrator -->
      <div v-if="isManager || isAdmin" class="form-group">
        <label for="chocolateFactory">Factory Name:</label>
        <input type="text" v-model="chocolateFactory" class="form-control" placeholder="Enter factory name">
      </div>

      <button type="submit" class="custom-btn btn-7">Register</button>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Register',
  data() {
    return {
      username: '',
      password: '',
      firstName: '',
      lastName: '',
      gender: '',
      dateOfBirth: '',
      chocolateFactory: '',  // Polje za unos fabrike
      selectedRole: 'Kupac'  // Podrazumevana uloga je Kupac
    };
  },
  computed: {
    isAdmin() {
      const user = JSON.parse(localStorage.getItem('fulluser'));
      return user && user.role === 'Administrator';
    },
    isManager() {
      const user = JSON.parse(localStorage.getItem('fulluser'));
      return user && user.role === 'Menadzer';
    }
  },
  methods: {
    register() {
      const role = this.isAdmin ? this.selectedRole : (this.isManager ? 'Radnik' : 'Kupac');  // Ako je administrator, koristi odabranu ulogu, inače postavlja odgovarajuću

      axios.post('http://localhost:3000/users/register', {
        username: this.username,
        password: this.password,
        firstName: this.firstName,
        lastName: this.lastName,
        gender: this.gender,
        dateOfBirth: this.dateOfBirth,
        role: role,  // Automatsko postavljanje uloge
        purchases: [],
        cart: [],
        chocolateFactory: (this.isAdmin || this.isManager) ? this.chocolateFactory : null,  // Ako je administrator ili menadžer, postavlja se fabrika
        collectedPoints: 0,
        customerType: null
      })
      .then(response => {
        console.log("Registration successful", response);
        this.$router.push('/login');  // Preusmeravanje na login stranicu posle uspešne registracije
      })
      .catch(error => {
        console.error("Error registering user", error);
      });
    }
  }
};
</script>

<style scoped>
.container {
  max-width: 600px;
  margin: 50px auto;
  padding: 20px;
  border: 1px solid #ccc;
  border-radius: 10px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
  background-color: #fff;
}

h2 {
  text-align: center;
  margin-bottom: 20px;
}

.form-group {
  margin-bottom: 15px;
}

.form-group label {
  display: block;
  margin-bottom: 5px;
  font-weight: bold;
}

.form-group input, .form-group select {
  width: 100%;
  padding: 10px;
  box-sizing: border-box;
  border: 1px solid #ccc;
  border-radius: 5px;
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 1.0s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 7 */
.btn-7 {
  background: linear-gradient(0deg, rgba(255,151,0,1) 0%, rgba(251,75,2,1) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
}
.btn-7 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-7:before,
.btn-7:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7:before {
  height: 0%;
  width: 2px;
}
.btn-7:after {
  width: 0%;
  height: 2px;
}
.btn-7:hover {
  color: rgba(251,75,2,1);
  background: transparent;
}
.btn-7:hover:before {
  height: 100%;
}
.btn-7:hover:after {
  width: 100%;
}
.btn-7 span:before,
.btn-7 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7 span:before {
  width: 2px;
  height: 0%;
}
.btn-7 span:after {
  height: 2px;
  width: 0%;
}
.btn-7 span:hover:before {
  height: 100%;
}
.btn-7 span:hover:after {
  width: 100%;
}

</style>
